package com.kirkk.test;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import junit.framework.TestCase;
import jdepend.framework.*;

/**
 * Tests various package dependency structures using JDepend.
 */
public class CycleTest extends TestCase {

	private JDepend jDepend;

	public CycleTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
	}

	protected void setUp() throws Exception {
		jDepend = new JDepend();
		jDepend.addDirectory("build/com/kirkk/cust");
        jDepend.addDirectory("build/com/kirkk/bill");
	}

	/*public void testAllDependenciesV1() {
		jDepend.analyze();
		assertEquals("Cycles exist", false, jDepend.containsCycles());
	}
	public void testAllDependenciesV2() {

		jDepend.analyze();

        JavaPackage util = jDepend.getPackage("com.extensiblejava.util");
		JavaPackage client = jDepend.getPackage("com.extensiblejava.client");

		assertEquals("Cycle exists: " + util.getName(),false, client.containsCycle());
		assertEquals("Cycle exists: " + client.getName(),false, util.containsCycle());
	}*/

	public void testAllDependencies() {
		jDepend.analyze();
		java.util.Iterator i = jDepend.getPackages().iterator();
		ArrayList cyclePackages = new ArrayList();
		while (i.hasNext()) {
			JavaPackage p = (JavaPackage) i.next();

			if (p.containsCycle()) {
				cyclePackages.add(p);
			}
		}
		assertEquals("Cycles exist: " + getCycles(cyclePackages), 0, cyclePackages.size());
	}

	private String getCycles(List cyclePackages) {
		String cycleDisplay = "";
		Iterator packages = cyclePackages.iterator();
		while (packages.hasNext()) {
			JavaPackage javaPackage = (JavaPackage) packages.next();
			String cycles = javaPackage.getName() + " to " + getCyclePackages(javaPackage);
			cycleDisplay = cycleDisplay + cycles + "\n";

		}
		return cycleDisplay;
	}
	private String getCyclePackages(JavaPackage p) {
		List list = new ArrayList();
		p.collectCycle(list);

		JavaPackage cyclePackage = (JavaPackage) list.get(list.size() - 1);
		String cyclePackageName = cyclePackage.getName();

		int i = 0;
		Iterator pkgIter = list.iterator();
		String cycleList = null;
		while (pkgIter.hasNext()) {
			i++;

			JavaPackage pkg = (JavaPackage) pkgIter.next();
			if (i != 1) {
				if (!pkg.getName().equals(cyclePackageName)) {
					if (cycleList == null) {
						cycleList = pkg.getName();
					} else {
						cycleList = cycleList + ", " + pkg.getName();
					}
				}
			}
		}

		return cycleList;
	}

}
