/**	Questions: How do you easily change the way Descendent performs strategy?
		How do you easily change the way Descendent performs reuse?
*/
public class Static {
	public static void main(String args[]) {

		Ancestor a = new Descendent();
		a.strategy();
		a.reuse();
		a.template();
	}
}

abstract class Ancestor {
	//Use inheritence for polymorphism.
	public abstract void strategy();

	//Using inheritance for reuse.
	public final void reuse() { System.out.println("Ancestor reuse"); }

	//Use inheritance for reuse & polymorphism.
	protected abstract void templateMethod();
	public void template() {
		System.out.println("Ancestor template");
		this.templateMethod();
	}
}

class Descendent extends Ancestor {

	protected void templateMethod() { System.out.println("Descendent templateMethod"); }

	public void strategy() { System.out.println("Descendent strategy"); }
}