package com.kirkk.test;

import junit.framework.*;
import junit.textui.*;
import jdepend.framework.*;

public class DependencyConstraintTest extends TestCase {
	private JDepend jDepend;

	public static void main(String[] args) {
        junit.textui.TestRunner.run(DependencyConstraintTest.class);
    }

	public DependencyConstraintTest(String name) {
		super(name);
	}

	protected void setUp() throws Exception {
		PackageFilter filter = new PackageFilter();
		filter.addPackage("java.*");
		jDepend = new JDepend(filter);

		java.io.File file = new java.io.File("build");
		System.out.println(file.getAbsolutePath());
        jDepend.addDirectory("build/com/kirkk/cust");
        jDepend.addDirectory("build/com/kirkk/bill");

	}

	public void testPackageDependencies() {
		DependencyConstraint constraint = new DependencyConstraint();

		JavaPackage cust = constraint.addPackage("com.kirkk.cust");
		JavaPackage bill = constraint.addPackage("com.kirkk.bill");

		cust.dependsUpon(bill);
		bill.dependsUpon(cust);

		jDepend.analyze();

		assertEquals("Dependency Mismatch", true, jDepend.dependencyMatch(constraint));

	}

	/*public void testCycles() {

		 java.util.Collection packages = jDepend.analyze();

		 assertEquals("Cycles exist", false, jDepend.containsCycles());


	}*/
}